Option Explicit On 
Option Strict On
Option Compare Binary

Imports System
Imports System.Drawing

' <remarks>
'   Speichert die Konfigurationseinstellungen und 
'   wird beispielsweise in eine XML-Datei
'   serialisiert. Um zustzliche Einstellungen zu 
'   untersttzen, mssen hier entsprechende
'   Eigenschaften hinzugefgt werden.
' </remarks>
<Serializable()> _
Public Class ConfigurationData
    Private m_ptRectanglePosition As Point
    Private m_intRectangleColor As Integer

    ' <summary>
    '   Erstellt eine neue Instanz der Klasse.
    ' </summary>
    ' 
    ' Fr Serialisierung muss ein Standard-Konstruktor 
    ' definiert werden.
    '
    Public Sub New()
    End Sub

    ' <summary>
    '   Erstellt eine neue Instanz der Klasse 
    '   und weist den Eigenschaften die in den 
    '   Parametern bergebenen Werte zu.
    ' </summary>
    ' <param name="ptRectanglePosition">Wert der Eigenschaft 
    '    <c>RectanglePosition</c>.</param>
    ' <param name="colorRectangleColor">Wert der Eigenschaft 
    '    <c>RectangleColor</c>.</param>
    Public Sub New( _
      ByVal ptRectanglePosition As Point, _
      ByVal colorRectangleColor As Color)
        Me.RectangleColor = colorRectangleColor.ToArgb()
        Me.RectanglePosition = ptRectanglePosition
    End Sub

    ' <summary>
    '   Gibt die Position des Rechtecks an 
    '   oder gibt sie zurck.
    ' </summary>
    ' <value>Position des Rechtecks.</value>
    Public Property RectanglePosition() As Point
        Get
            Return m_ptRectanglePosition
        End Get
        Set(ByVal Value As Point)
            m_ptRectanglePosition = Value
        End Set
    End Property

    ' <summary>
    '   Gibt die Farbe des Rechtecks an 
    '   oder gibt sie zurck.
    ' </summary>
    ' <value>Farbe des Rechtecks.</value>
    Public Property RectangleColor() As Integer
        Get
            Return m_intRectangleColor
        End Get
        Set(ByVal Value As Integer)
            m_intRectangleColor = Value
        End Set
    End Property
End Class